<form novalidate [formGroup]="form">

    <table>
        <tr>
            <th>Name</th>
            <td>
                <input type="text" [formControl]="name"/>
            </td>
            <td>
                <ul *ngIf="name.invalid && name.dirty">
                    <li *ngIf="name.errors.required">Must enter some text</li>
                    <li *ngIf="name.errors.minlength">
                        Must have at least {{name.errors.minlength.requiredLength}} chars
                    </li>
                </ul>
            </td>
        </tr>

        <tr>
            <th>Age</th>
            <td>
                <input type="number" [formControl]="age"/>
            </td>
            <td>
                <ul *ngIf="age.invalid && age.dirty">
                    <li *ngIf="age.errors.min">Must be at least 20</li>
                    <li *ngIf="age.errors.max">Must be at most 80</li>
                </ul>
            </td>
        </tr>

        <tr>
            <th></th>
            <td colspan="2">
                <button type="button" (click)="onSubmit()" [disabled]="form.invalid">
                    SEND Form
                </button>
            </td>
        </tr>
    </table>

</form>
